## inventor 2.1.6+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
set (CMAKE_C_STANDARD 99)
set (CMAKE_CXX_STANDARD 98)
set (CXX_STANDARD_REQUIRED ON) 
set(CMAKE_CXX_EXTENSIONS OFF)


project("Open Inventor"
    VERSION 2.1.6
    DESCRIPTION "Object oriented OpenGL scene graph"
    HOMEPAGE_URL "http://oss.sgi.com/projects/inventor/"
    LANGUAGES CXX C)

include(GNUInstallDirs)
include(FeatureSummary)

option(INVENTOR_MAN "Build man pages" ON)
option(INVENTOR_NODES "Build node type extension plug-ins" ON)
option(INVENTOR_DEMOS "Build demo applications" ON)
option(INVENTOR_SAMPLES "Build sample applications" OFF)
option(INVENTOR_EXAMPLES "Build examples from Inventor Mentor and Inventor Toolmaker books" OFF)

option(INVENTOR_INTERNAL_GLW "Use included copy of GLw (OpenGL Xt/Motif widgets) library" ON)
option(INVENTOR_INSTALL_RPATH "Apply rpath when installing" ON)

option(INVENTOR_SANITIZE_UNDEFINED "Build with -fsanitize=undefined" OFF)
option(INVENTOR_SANITIZE_ADDRESS "Build with -fsanitize=address" OFF)
option(INVENTOR_SANITIZE_THREAD "Build with -fsanitize=thread" OFF)

set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
# this is used to override some of cmake's original find-modules
if(APPLE)
    # don't use Frameworks and use X11 with matching OpenGL
    set(CMAKE_FIND_FRAMEWORK NEVER)
    set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/apple;${CMAKE_MODULE_PATH}")
endif()

if (CMAKE_BUILD_TYPE STREQUAL "")
   set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
      FORCE
   )
   message("Setting CMAKE_BUILD_TYPE to ${CMAKE_BUILD_TYPE}")
endif()

set(BUILD_SHARED_LIBS TRUE)
if (BUILD_SHARED_LIBS AND INVENTOR_INSTALL_RPATH)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_options(-Wno-write-strings)
elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wno-c++11-compat-deprecated-writable-strings)
    add_compile_options(-Wno-backslash-newline-escape)
    add_compile_options(-Wno-dangling-else)
    add_compile_options(-Wno-parentheses)
    add_compile_options(-Wno-switch)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-fno-strict-aliasing)
    add_compile_options(-funsigned-char)
endif()

set(ASAN_COMPILE_FLAGS)
set(ASAN_LINK_FLAGS)
if (INVENTOR_SANITIZE_UNDEFINED)
   set(ASAN_LINK_FLAGS ${ASAN_LINK_FLAGS} -fsanitize=undefined)
   set(ASAN_COMPILE_FLAGS ${ASAN_COMPILE_FLAGS} -fsanitize=undefined)
endif()
if (INVENTOR_SANITIZE_ADDRESS)
   set(ASAN_LINK_FLAGS ${ASAN_LINK_FLAGS} -fsanitize=address)
   set(ASAN_COMPILE_FLAGS ${ASAN_COMPILE_FLAGS} -fsanitize=address)
   set(ASAN_COMPILE_FLAGS${ASAN_COMPILE_FLAGS} -fsanitize-address-use-after-scope)
endif()
if (INVENTOR_SANITIZE_THREAD)
   set(ASAN_LINK_FLAGS ${ASAN_LINK_FLAGS} -fsanitize=thread)
   set(ASAN_COMPILE_FLAGS ${ASAN_COMPILE_FLAGS} -fsanitize=thread)
endif()
if (INVENTOR_SANITIZE_THREAD OR INVENTOR_SANITIZE_ADDRESS OR INVENTOR_SANITIZE_UNDEFINED)
   set(ASAN_COMPILE_FLAGS ${ASAN_COMPILE_FLAGS} -fno-omit-frame-pointer)
   if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
       add_compile_options(${ASAN_COMPILE_FLAGS})
       add_link_options(${ASAN_LINK_FLAGS})
   endif()
endif()

find_program(SED_EXECUTABLE
    NAMES sed
    DOC "sed stream editor"
    REQUIRED
)

find_package(StandardMathLibrary)
find_package(BISON REQUIRED)
find_package(JPEG REQUIRED)
set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL REQUIRED)
find_package(X11 REQUIRED)
find_package(Iconv REQUIRED)
find_package(Motif REQUIRED)
if (NOT INVENTOR_INTERNAL_GLW)
    find_package(GLw REQUIRED)
endif()

macro(ADD_DIRVAR VAR DIR)
    set(${VAR} ${DIR})
    add_definitions(-D${VAR}="${CMAKE_INSTALL_PREFIX}/${DIR}")
endmacro()

add_dirvar(IVBINDIR "${CMAKE_INSTALL_BINDIR}")
add_dirvar(IVHELPDIR "${CMAKE_INSTALL_DATADIR}/inventor/help")
add_dirvar(IVFONTPATH "${CMAKE_INSTALL_DATADIR}/inventor/fonts")
set(IVDATAROOT "${CMAKE_INSTALL_DATADIR}/inventor/data")
add_dirvar(IVDATADIR "${IVDATAROOT}/models")
add_dirvar(IVMATERIALSDIR "${IVDATAROOT}/materials")
add_dirvar(IVTEXTURESDIR "${IVDATAROOT}/textures")
add_dirvar(IVDEMODATADIR "${IVDATAROOT}/demos")
#add_dirvar(IVDEMOBINDIR "libexec/inventor")
add_dirvar(IVDEMOBINDIR "${CMAKE_INSTALL_LIBDIR}/inventor")

set(IVHDRTOP Inventor)

if(APPLE)
    set(PDFVIEWER "open")
else()
    set(PDFVIEWER "xdg-open")
endif()
add_definitions(-DPDFVIEWER="${PDFVIEWER}")

add_subdirectory(tools)
add_subdirectory(libimage)
add_subdirectory(libFL)
add_subdirectory(lib)
add_subdirectory(libSoXt)
add_subdirectory(doc)
add_subdirectory(apps)
add_subdirectory(data)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES)

=== apps/CMakeLists.txt ===
add_subdirectory(samples)
if (INVENTOR_NODES)
    add_subdirectory(nodes)
endif()
add_subdirectory(tools)
add_subdirectory(converters)
add_subdirectory(demos)
if (INVENTOR_EXAMPLES)
    add_subdirectory(examples)
endif()

=== data/CMakeLists.txt ===
add_subdirectory(models)
#add_subdirectory(textures)

=== doc/CMakeLists.txt ===
if (INVENTOR_MAN)
    add_subdirectory(man)
endif()
add_subdirectory(help)

=== lib/CMakeLists.txt ===
macro(ADD_PP_FILES outfiles)
    foreach(it ${ARGN})
        get_filename_component(outbase ${it} NAME_WE)
        get_filename_component(infile ${it} ABSOLUTE)
        set(outfile ${CMAKE_CURRENT_BINARY_DIR}/${outbase}.c++)

        add_custom_command(OUTPUT ${outfile}
            COMMAND ppp < ${infile} > ${outfile}
            MAIN_DEPENDENCY ${infile}
            VERBATIM)
        set(${outfiles} ${${outfiles}} ${outfile})
    endforeach ()
endmacro()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
bison_target(CALCPARSE
    database/src/so/engines/SoCalcParse.y
    ${CMAKE_CURRENT_BINARY_DIR}/SoCalcParse.c++
)

add_pp_files(PP_SOURCES
    database/src/so/nodes/SoCone.pp
    database/src/so/nodes/SoCube.pp
    database/src/so/nodes/SoCylinder.pp
    database/src/so/nodes/SoFaceSet.pp
    database/src/so/nodes/SoIndexedFaceSet.pp
    database/src/so/nodes/SoIndexedLineSet.pp
    database/src/so/nodes/SoLineSet.pp
    database/src/so/nodes/SoPointSet.pp
    database/src/so/nodes/SoIndexedTriangleStripSet.pp
    database/src/so/nodes/SoQuadMesh.pp
    database/src/so/nodes/SoSphere.pp
    database/src/so/nodes/SoTriangleStripSet.pp
)

add_library(Inventor)

target_sources(Inventor
    PRIVATE
    ${PP_SOURCES}
    database/src/sb/projectors/SbProjectors.c++
    database/src/sb/Sb.c++
    database/src/so/actions/SoActions.c++
    database/src/so/bundles/SoBundles.c++
    database/src/so/caches/SoCaches.c++
    database/src/so/details/SoDetails.c++
    database/src/so/elements/SoElement.c++
    database/src/so/elements/SoElements.c++
    database/src/so/engines/SoEngines.c++
    database/src/so/engines/SoConcatenate.c++
    database/src/so/engines/SoEngineInit.c++
    database/src/so/engines/SoFieldConverters.c++
    database/src/so/engines/SoGate.c++
    database/src/so/engines/SoSelectOne.c++
    database/src/so/errors/SoErrors.c++
    database/src/so/errors/SoErrorInit.c++
    database/src/so/events/SoEventInit.c++
    database/src/so/events/SoEvents.c++
    database/src/so/fields/SoField.c++
    database/src/so/fields/SoFieldContainer.c++
    database/src/so/fields/SoFieldData.c++
    database/src/so/fields/SoFieldInit.c++
    database/src/so/fields/SoFields.c++
    database/src/so/fields/SoGlobalField.c++
    database/src/so/nodes/nurbs/clients/nurbsClient.c++
    database/src/so/nodes/nurbs/libnurbs/libNurbs.c++
    database/src/so/nodes/nurbs/SoNurbs.c++
    database/src/so/nodes/SoNode.c++
    database/src/so/nodes/SoNodeInit.c++
    database/src/so/nodes/SoAnnotation.c++
    database/src/so/nodes/SoArray.c++
    database/src/so/nodes/SoAsciiText.c++
    database/src/so/nodes/SoBaseColor.c++
    database/src/so/nodes/SoBlinker.c++
    database/src/so/nodes/SoCallback.c++
    database/src/so/nodes/SoCamera.c++
    database/src/so/nodes/SoClipPlane.c++
    database/src/so/nodes/SoColorIndex.c++
    database/src/so/nodes/SoComplexity.c++
    database/src/so/nodes/SoCoordinate3.c++
    database/src/so/nodes/SoCoordinate4.c++
    database/src/so/nodes/SoDrawStyle.c++
    database/src/so/nodes/SoDirectionalLight.c++
    database/src/so/nodes/SoEnvironment.c++
    database/src/so/nodes/SoFile.c++
    database/src/so/nodes/SoFont.c++
    database/src/so/nodes/SoGroup.c++
    database/src/so/nodes/SoEventCallback.c++
    database/src/so/nodes/SoFontStyle.c++
    database/src/so/nodes/SoInfo.c++
    database/src/so/nodes/SoIndexedNurbsCurve.c++
    database/src/so/nodes/SoIndexedShape.c++
    database/src/so/nodes/SoLOD.c++
    database/src/so/nodes/SoLabel.c++
    database/src/so/nodes/SoLight.c++
    database/src/so/nodes/SoIndexedNurbsSurface.c++
    database/src/so/nodes/SoLevelOfDetail.c++
    database/src/so/nodes/SoMaterial.c++
    database/src/so/nodes/SoLocateHighlight.c++
    database/src/so/nodes/SoLightModel.c++
    database/src/so/nodes/SoLinearProfile.c++
    database/src/so/nodes/SoNormal.c++
    database/src/so/nodes/SoMaterialBinding.c++
    database/src/so/nodes/SoMultipleCopy.c++
    database/src/so/nodes/SoNurbsCurve.c++
    database/src/so/nodes/SoNurbsProfile.c++
    database/src/so/nodes/SoMatrixTransform.c++
    database/src/so/nodes/SoNurbsSurface.c++
    database/src/so/nodes/SoPackedColor.c++
    database/src/so/nodes/SoPendulum.c++
    database/src/so/nodes/SoNonIndexedShape.c++
    database/src/so/nodes/SoPathSwitch.c++
    database/src/so/nodes/SoProfile.c++
    database/src/so/nodes/SoNormalBinding.c++
    database/src/so/nodes/SoRotation.c++
    database/src/so/nodes/SoPickStyle.c++
    database/src/so/nodes/SoRotor.c++
    database/src/so/nodes/SoPointLight.c++
    database/src/so/nodes/SoScale.c++
    database/src/so/nodes/SoShape.c++
    database/src/so/nodes/SoShuttle.c++
    database/src/so/nodes/SoOrthographicCamera.c++
    database/src/so/nodes/SoRotationXYZ.c++
    database/src/so/nodes/SoSwitch.c++
    database/src/so/nodes/SoText2.c++
    database/src/so/nodes/SoPerspectiveCamera.c++
    database/src/so/nodes/SoProfileCoordinate2.c++
    database/src/so/nodes/SoProfileCoordinate3.c++
    database/src/so/nodes/SoResetTransform.c++
    database/src/so/nodes/SoSeparator.c++
    database/src/so/nodes/SoShapeHints.c++
    database/src/so/nodes/SoText3.c++
    database/src/so/nodes/SoSpotLight.c++
    database/src/so/nodes/SoTexture2.c++
    database/src/so/nodes/SoTextureCoordinate2.c++
    database/src/so/nodes/SoTransform.c++
    database/src/so/nodes/SoTextureCoordinateBinding.c++
    database/src/so/nodes/SoUnits.c++
    database/src/so/nodes/SoTransformation.c++
    database/src/so/nodes/readGIF.c
    database/src/so/nodes/SoTranslation.c++
    database/src/so/nodes/SoUnknownNode.c++
    database/src/so/nodes/SoVertexShape.c++
    database/src/so/nodes/SoWWWAnchor.c++
    database/src/so/nodes/SoTextureCoordinateDefault.c++
    database/src/so/nodes/SoVertexProperty.c++
    database/src/so/nodes/SoTextureCoordinateFunction.c++
    database/src/so/nodes/SoTextureCoordinateEnvironment.c++
    database/src/so/nodes/SoTextureCoordinatePlane.c++
    database/src/so/nodes/SoTexture2Transform.c++
    database/src/so/nodes/SoTransformSeparator.c++
    database/src/so/nodes/SoWWWInline.c++
    database/src/so/sensors/SoSensors.c++
    database/src/so/upgraders/SoUpgraderInit.c++
    database/src/so/upgraders/SoUpgrader.c++
    database/src/so/upgraders/SoUpgraders.c++
    database/src/so/So.c++
    database/src/so/SoState.c++
    database/src/so/linux.c++

    database/src/so/engines/SoCalcExpr.h
    database/src/so/engines/SoEngineUtil.h
    database/src/so/engines/SoFieldConverters.h
    database/src/so/fields/SoGlobalField.h
    database/src/so/nodes/nurbs/SoCurveRenderEval.h
    database/src/so/nodes/nurbs/SoPickEvals.h
    database/src/so/nodes/nurbs/SoPrimEvals.h
    database/src/so/nodes/nurbs/_defines.h
    database/src/so/nodes/nurbs/_undefs.h
    database/src/so/nodes/nurbs/clients/gl4curveval.h
    database/src/so/nodes/nurbs/clients/gl4surfeval.h
    database/src/so/nodes/nurbs/clients/gl4types.h
    database/src/so/nodes/nurbs/clients/isocurveeval.h
    database/src/so/nodes/nurbs/clients/softcurvemaps.h
    database/src/so/nodes/nurbs/clients/softcurveval.h
    database/src/so/nodes/nurbs/clients/softcurvmap.h
    database/src/so/nodes/nurbs/clients/softrenderer.h
    database/src/so/nodes/nurbs/clients/softsurfacemaps.h
    database/src/so/nodes/nurbs/clients/softsurfeval.h
    database/src/so/nodes/nurbs/clients/softsurfmap.h
    database/src/so/nodes/nurbs/clients/typestringtable.h
    database/src/so/nodes/nurbs/clients/gl4base.h
    database/src/so/nodes/nurbs/head/arc.h
    database/src/so/nodes/nurbs/head/arcsorter.h
    database/src/so/nodes/nurbs/head/arctess.h
    database/src/so/nodes/nurbs/head/backend.h
    database/src/so/nodes/nurbs/head/basiccrveval.h
    database/src/so/nodes/nurbs/head/basicsurfeval.h
    database/src/so/nodes/nurbs/head/bezierarc.h
    database/src/so/nodes/nurbs/head/bin.h
    database/src/so/nodes/nurbs/head/bufpool.h
    database/src/so/nodes/nurbs/head/cachingeval.h
    database/src/so/nodes/nurbs/head/coveandtiler.h
    database/src/so/nodes/nurbs/head/curve.h
    database/src/so/nodes/nurbs/head/curvelist.h
    database/src/so/nodes/nurbs/head/defines.h
    database/src/so/nodes/nurbs/head/displaylist.h
    database/src/so/nodes/nurbs/head/displaymode.h
    database/src/so/nodes/nurbs/head/flist.h
    database/src/so/nodes/nurbs/head/flistsorter.h
    database/src/so/nodes/nurbs/head/gridline.h
    database/src/so/nodes/nurbs/head/gridtrimvertex.h
    database/src/so/nodes/nurbs/head/gridvertex.h
    database/src/so/nodes/nurbs/head/hull.h
    database/src/so/nodes/nurbs/head/jarcloc.h
    database/src/so/nodes/nurbs/head/jumpbuffer.h
    database/src/so/nodes/nurbs/head/knot.h
    database/src/so/nodes/nurbs/head/knotvector.h
    database/src/so/nodes/nurbs/head/mapdesc.h
    database/src/so/nodes/nurbs/head/maplist.h
    database/src/so/nodes/nurbs/head/mesher.h
    database/src/so/nodes/nurbs/head/myassert.h
    database/src/so/nodes/nurbs/head/myglimports.h
    database/src/so/nodes/nurbs/head/mysetjmp.h
    database/src/so/nodes/nurbs/head/mystdlib.h
    database/src/so/nodes/nurbs/head/mystring.h
    database/src/so/nodes/nurbs/head/nurbsconsts.h
    database/src/so/nodes/nurbs/head/nurbstess.h
    database/src/so/nodes/nurbs/head/patch.h
    database/src/so/nodes/nurbs/head/patchlist.h
    database/src/so/nodes/nurbs/head/pwlarc.h
    database/src/so/nodes/nurbs/head/quilt.h
    database/src/so/nodes/nurbs/head/reader.h
    database/src/so/nodes/nurbs/head/renderhints.h
    database/src/so/nodes/nurbs/head/slicer.h
    database/src/so/nodes/nurbs/head/sorter.h
    database/src/so/nodes/nurbs/head/subdivider.h
    database/src/so/nodes/nurbs/head/trimline.h
    database/src/so/nodes/nurbs/head/trimregion.h
    database/src/so/nodes/nurbs/head/trimvertex.h
    database/src/so/nodes/nurbs/head/trimvertpool.h
    database/src/so/nodes/nurbs/head/types.h
    database/src/so/nodes/nurbs/head/uarray.h
    database/src/so/nodes/nurbs/head/varray.h
    database/src/so/nodes/nurbs/head/glimports.h
    database/src/so/nodes/nurbs/head/mymath.h
    database/src/so/nodes/nurbs/head/mystdio.h
    database/src/so/nodes/nurbs/head/simplemath.h
    database/src/so/nodes/nurbs/SoAddPrefix.h
    database/src/so/nodes/nurbs/SoCurveMaps.h
    database/src/so/nodes/nurbs/SoCurveRender.h
    database/src/so/nodes/nurbs/SoGLRender.h
    database/src/so/nodes/nurbs/SoPickMaps.h
    database/src/so/nodes/nurbs/SoPickRender.h
    database/src/so/nodes/nurbs/SoPrimMaps.h
    database/src/so/nodes/nurbs/SoPrimRender.h
    database/src/so/nodes/readGIF.h
    database/src/so/upgraders/SoUpgraders.h
    database/src/so/upgraders/SoV1DrawStyle.h
    database/src/so/upgraders/SoV1Environment.h
    database/src/so/upgraders/SoV1IndexedTriangleMesh.h
    database/src/so/upgraders/SoV1LayerGroup.h
    database/src/so/upgraders/SoV1LightModel.h
    database/src/so/upgraders/SoV1Material.h
    database/src/so/upgraders/SoV1PackedColor.h
    database/src/so/upgraders/SoV1PickStyle.h
    database/src/so/upgraders/SoV1Separator.h
    database/src/so/upgraders/SoV1ShapeHints.h
    database/src/so/upgraders/SoV1Text2.h
    database/src/so/upgraders/SoV1Text3.h
    database/src/so/upgraders/SoV1Texture2.h
    database/src/so/upgraders/SoV1TextureCoordinateCube.h
    database/src/so/upgraders/SoV1TextureCoordinateCylinder.h
    database/src/so/upgraders/SoV1TextureCoordinateEnvironment.h
    database/src/so/upgraders/SoV1TextureCoordinatePlane.h
    database/src/so/upgraders/SoV1TextureCoordinateSphere.h
    database/src/so/upgraders/SoV2AsciiText.h
    database/src/so/upgraders/SoV2FontStyle.h
    database/src/so/upgraders/SoV2LOD.h
    database/src/so/upgraders/SoV2MaterialIndex.h
    database/src/so/upgraders/SoV2Text2.h
    database/src/so/upgraders/SoV2Text3.h
    database/src/so/upgraders/SoV2VertexProperty.h
    database/src/so/upgraders/SoV2WWWAnchor.h
    database/src/so/upgraders/SoV2WWWInline.h

    PUBLIC

=== libFL/CMakeLists.txt ===
find_package(Freetype REQUIRED)

add_library(FLiv STATIC
    fl.c flclient.c flfreetype.c
    fl.h flclient.h flfreetype.h
)

set_property(TARGET FLiv PROPERTY POSITION_INDEPENDENT_CODE ON)

target_link_libraries(FLiv PRIVATE Freetype::Freetype)
target_link_libraries(FLiv PRIVATE OpenGL::GL)

target_include_directories(FLiv PUBLIC .)

=== libSoXt/CMakeLists.txt ===
add_library(InventorXt)

target_sources(InventorXt
    PRIVATE
    src/devices/SoXtFocus.c++
    src/devices/SoXtKeybd.c++
    src/devices/SoXtMouse.c++
    src/devices/SoXtSpball.c++
    src/lightEditor/SoXtDirLitEd.c++
    src/mixedMode/SoFloatCBList.c++
    src/mixedMode/SoXtColEd.c++
    src/mixedMode/SoXtColPatch.c++
    src/mixedMode/SoXtColSlider.c++
    src/mixedMode/SoXtColWheel.c++
    src/mixedMode/SoXtSlider.c++
    src/mixedMode/SoXtUIRegion.c++
    src/motif/SoXtCntlPnl.c++
    src/motif/SoXtFltTxt.c++
    src/motif/SoXtLtSldrSet.c++
    src/motif/SoXtMMSldrMax.c++
    src/motif/SoXtMMSldrMin.c++
    src/motif/SoXtMinMax.c++
    src/motif/SoXtMltSldr.c++
    src/motif/SoXtMltSldrs.c++
    src/motif/SoXtMtlSSet.c++
    src/motif/SoXtSSetBase.c++
    src/motif/SoXtSldrMdl.c++
    src/motif/SoXtSldrMdls.c++
    src/motif/SoXtSldrSet.c++
    src/motif/SoXtSldrTl.c++
    src/motif/SoXtTfSldrSet.c++
    src/mtlEdit/SoXtMtlEdit.c++
    src/mtlEdit/SoXtMtlList.c++
    src/viewers/SoXtBitmapButton.c++
    src/viewers/SoXtConstVwr.c++
    src/viewers/SoXtCursors.c++
    src/viewers/SoXtExamVwr.c++
    src/viewers/SoXtFlyVwr.c++
    src/viewers/SoXtFullVwr.c++
    src/viewers/SoXtIcons.c++
    src/viewers/SoXtPlaneVwr.c++
    src/viewers/SoXtViewer.c++
    src/viewers/SoXtWalkVwr.c++
    src/viewers/Sgm/ThumbWheel.c
    src/SoGLwDAUtil.c
    src/SoGLwDrawA.c
    src/SoGLwMDrawA.c
    src/SoXt.c++
    src/SoXtClipboard.c++
    src/SoXtComponent.c++
    src/SoXtGLWidget.c++
    src/SoXtImportInterest.c++
    src/SoXtPrintDlog.c++
    src/SoXtRendrArea.c++
    src/SoXtRsrc.c++
    src/sgi_visual.c

    src/mixedMode/SoFloatCallbackList.h
    src/viewers/Sgm/ThumbWheel.h
    src/viewers/Sgm/ThumbWheelP.h
    src/viewers/SoXtBitmapButton.h
    src/sgi_visual.h

    PUBLIC
    include/Inventor/Xt/SoXt.h
    include/Inventor/Xt/SoXtClipboard.h
    include/Inventor/Xt/SoXtComponent.h
    include/Inventor/Xt/SoXtCursors.h
    include/Inventor/Xt/SoXtDirectionalLightEditor.h
    include/Inventor/Xt/SoXtGLWidget.h
    include/Inventor/Xt/SoXtIcons.h
    include/Inventor/Xt/SoXtLightSliderSet.h
    include/Inventor/Xt/SoXtMaterialEditor.h
    include/Inventor/Xt/SoXtMaterialList.h
    include/Inventor/Xt/SoXtMaterialSliderSet.h
    include/Inventor/Xt/SoXtPrintDialog.h
    include/Inventor/Xt/SoXtRenderArea.h
    include/Inventor/Xt/SoXtResource.h
    include/Inventor/Xt/SoXtSliderSet.h
    include/Inventor/Xt/SoXtSliderSetBase.h
    include/Inventor/Xt/SoXtTransformSliderSet.h
    include/Inventor/Xt/devices/SoXtDevice.h
    include/Inventor/Xt/devices/SoXtInputFocus.h
    include/Inventor/Xt/devices/SoXtKeyboard.h
    include/Inventor/Xt/devices/SoXtMouse.h
    include/Inventor/Xt/devices/SoXtSpaceball.h
    include/Inventor/Xt/viewers/SoXtConstrainedViewer.h
    include/Inventor/Xt/viewers/SoXtFlyViewer.h
    include/Inventor/Xt/viewers/SoXtFullViewer.h
    include/Inventor/Xt/viewers/SoXtPlaneViewer.h
    include/Inventor/Xt/viewers/SoXtViewer.h
    include/Inventor/Xt/viewers/SoXtWalkViewer.h
    include/Inventor/Xt/viewers/SoXtExaminerViewer.h
    include/SoGLwDrawAP.h
    include/SoGLwMDrawA.h
    include/SoGLwMDrawAP.h
    include/SoXtFloatText.h
    include/SoXtImportInterest.h
    include/SoXtMMSliderMax.h
    include/SoXtMMSliderMin.h
    include/SoXtMinMaxSlider.h
    include/SoXtMultiSlider.h
    include/SoXtMultiSliders.h
    include/SoXtSliderControlPanel.h
    include/SoXtSliderModule.h
    include/SoXtSliderModules.h
    include/SoXtSliderTool.h
    include/_SoXtColorEditor.h
    include/_SoXtColorPatch.h
    include/_SoXtColorSlider.h
    include/_SoXtColorWheel.h
    include/_SoXtSlider.h
    include/_SoXtUIRegion.h
    include/SoGLwDrawA.h
)

set_target_properties(InventorXt PROPERTIES
    #VERSION ${CMAKE_PROJECT_VERSION}
    VERSION 0.0.0
    SOVERSION 0
)

target_include_directories(InventorXt PRIVATE
    src/viewers
)

target_include_directories(InventorXt PUBLIC
    include
    ${MOTIF_INCLUDE_DIR}
)

target_link_libraries(InventorXt PUBLIC
    ${MOTIF_LIBRARIES}
    X11::Xt
    X11::X11
    X11::Xi
    Inventor
)

target_link_libraries(InventorXt PUBLIC OpenGL::GL OpenGL::GLU)

install(TARGETS InventorXt)

install(DIRECTORY include/Inventor/
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${IVHDRTOP}
    FILES_MATCHING PATTERN "*.h"
)

=== libimage/CMakeLists.txt ===
add_library(image STATIC
    close.c
    filbuf.c
    flsbuf.c
    name.c
    open.c
    pix.c
    rdwr.c
    rle.c
    row.c

    image.h
    image-intern.h
)

set_property(TARGET image PROPERTY POSITION_INDEPENDENT_CODE ON)

=== tools/CMakeLists.txt ===
add_subdirectory(ppp)

=== apps/converters/CMakeLists.txt ===
add_subdirectory(iv2toiv1)
add_subdirectory(ivdowngrade)

=== apps/demos/CMakeLists.txt ===
macro(ADD_DEMO APP)
    add_executable(${APP} ${ARGN})
    target_link_libraries(${APP} PRIVATE InventorXt Inventor)
    if (INVENTOR_DEMOS)
        install(TARGETS ${APP} DESTINATION ${IVDEMOBINDIR})
        if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${APP}.RUNME.in")
            configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${APP}.RUNME.in" "${CMAKE_CURRENT_BINARY_DIR}/${APP}.RUNME" @ONLY)
            install(PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${APP}.RUNME" DESTINATION ${IVDEMOBINDIR})
        elseif (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${APP}.RUNME")
            install(PROGRAMS "${APP}.RUNME" DESTINATION ${IVDEMOBINDIR})
        endif()
        if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${APP}.about.pdf")
            install(FILES "${APP}.about.pdf" DESTINATION ${IVDEMOBINDIR})
        endif()
    endif()
endmacro()

add_subdirectory(SceneViewer)
if (INVENTOR_DEMOS)
    add_subdirectory(drop)
    add_subdirectory(gview)
    add_subdirectory(maze)
    add_subdirectory(noodle)
    add_subdirectory(qmorf)
    add_subdirectory(revo)
    add_subdirectory(textomatic)
endif()

=== apps/examples/CMakeLists.txt ===
macro(ADD_EXAMPLE APP)
    add_executable(${APP} ${ARGN})
    target_link_libraries(${APP} InventorXt Inventor)
    #install(TARGETS ${APP} DESTINATION ${IVDEMOBINDIR})
endmacro()

add_subdirectory(Mentor)
add_subdirectory(Toolmaker)

=== debian/changelog ===
inventor (2.1.6+ds-2) unstable; urgency=medium

  * Restore logic for building manpages only on 64-bit architecture.
  * Do not install with RPATH.

 -- Steve M. Robbins <smr@debian.org>  Sun, 18 Aug 2024 01:37:21 -0500

inventor (2.1.6+ds-1) unstable; urgency=medium

  * Standards-Version: 4.7.0 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove constraints unnecessary since bullseye (oldstable):
    + Build-Depends: Replace dependency on transitional package
      x11proto-core-dev with replacement x11proto-dev.
  * [3e065a2] Switch upstream to github open-inventor (Closes: # 1066892)
    SGI has long ago removed their website.
  * [890f435] New upstream version 2.1.6
    + Rewrite build rules to use new CMake build.
    + Remove all existing patches - all were applied upstream, apart from
      setting a SOVERSION, which is now done in new soversion.patch.
    + Patched sources build with gcc-14 (Closes: #1075090)

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Aug 2024 21:35:02 -0500

inventor (2.1.5-10+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062454

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 11:29:26 +0000

=== debian/control ===
Source: inventor
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Section: devel
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               cmake,
               csh,
               libx11-dev,
               libxi-dev,
               libxt-dev,
               x11proto-dev,
               libmotif-dev,
               libglw1-mesa-dev,
               libglu1-mesa-dev,
               libfreetype-dev,
               libjpeg-dev,
               bison
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/inventor
Vcs-Git: https://salsa.debian.org/science-team/inventor.git
Homepage: https://github.com/aumuell/open-inventor/

Package: libinventor1t64
Provides: ${t64:Provides}
Breaks: libinventor1 (<< ${source:Version})
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
         xfonts-scalable,
         fonts-urw-base35
Recommends: xdg-utils,
            xpdf | pdf-viewer
Conflicts: libinventor0
Replaces: libinventor1, libinventor0
Description: Open Inventor runtime environment
 This package contains the required files to run Open Inventor applications.
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.
 .
 Recommended packages are needed only to view help files.

Package: inventor-dev
Architecture: any
Depends: ${misc:Depends},
         libinventor1t64 (= ${binary:Version}),
         libc6-dev,
         xlibmesa-dev | libgl-dev,
         libmotif-dev
Conflicts: libcoin20-dev,
           libcoin20-doc
Description: Open Inventor development files
 This package contains the files required to develop Open Inventor
 applications.
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.

Package: inventor-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Conflicts: libcoin20-doc,
           libcoin40-doc
Multi-Arch: foreign
Description: Open Inventor documentation
 This package contains the Open Inventor documentation files.
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.

Package: inventor-clients
Architecture: any
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Open Inventor client programs
 This package contains Open Inventor file viewers and converters.
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.

Package: inventor-data
Architecture: all
Section: graphics
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Open Inventor sample data files
 This package contains sample 3D model and scene files in inventor format.
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.

Package: inventor-demo
Architecture: any
Section: graphics
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Open Inventor demonstration programs and example code
 This package includes several Open Inventor demos: a scene viewer
 (SceneViewer), a scene graph viewer and editor (gview), a maze game (maze),
 an extrusion editor (noodle), a 3D morphing tool (qmorf), a surface of
 revolution editor (revo), among others.
 .
 This package also contains example code, including the examples
 from the books "The Inventor Mentor", and "The Inventor Toolmaker".
 .
 Open Inventor is an object-oriented 3D toolkit offering a comprehensive
 solution to interactive graphics programming problems.  It presents a
 programming model based on a 3D scene database that simplifies graphics
 programming.  It includes a large set of objects such as cubes, polygons,
 text, materials, cameras, lights, trackballs, handle boxes, 3D viewers, and
 editors can speed up your programming and extend your 3D program's
 capabilities.

=== debian/rules ===
#!/usr/bin/make -f

# Sadly, the program "ivman" used to generate manual pages
# is broken on several architectures.  It looks to me like
# there are assumptions being made about the form of mangled
# identifiers, or maybe some bad assumptions being broken on 64-bit
# architectures.  Whatever.
#
# The man pages are therefore only generated on certain architectures,
# but since it is an architecture "all" package, we only have to
# ensure that the uploader builds on a favoured architecture, e.g.
# i386.
#
export BUILDMAN=OFF
ifeq (64,$(DEB_BUILD_ARCH_BITS))
export BUILDMAN=ON
endif


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DCMAKE_SKIP_INSTALL_RPATH=ON \
		-DINVENTOR_MAN=$(BUILDMAN) \
		-DINVENTOR_NODES=OFF

override_dh_install:
ifeq (OFF,$(BUILDMAN))
	mkdir -p debian/tmp/usr/share/man/man1
	mkdir -p debian/tmp/usr/share/man/man3
endif
	dh_install

=== debian/watch ===
version=4

opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%,\
dversionmangle=s/\+ds$//,repacksuffix=+ds" \
https://api.github.com/repos/aumuell/open-inventor/releases?per_page=100 \
https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@

## inventor 2.1.6.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,10 +6,12 @@
 
 
 project("Open Inventor"
-    VERSION 2.1.6
+    VERSION 2.1.6.1
     DESCRIPTION "Object oriented OpenGL scene graph"
     HOMEPAGE_URL "http://oss.sgi.com/projects/inventor/"
     LANGUAGES CXX C)
+
+set(INVENTOR_SOVERSION 1)
 
 include(GNUInstallDirs)
 include(FeatureSummary)

=== libSoXt/CMakeLists.txt ===
--- 
+++ 
@@ -115,9 +115,8 @@
 )
 
 set_target_properties(InventorXt PROPERTIES
-    #VERSION ${CMAKE_PROJECT_VERSION}
-    VERSION 0.0.0
-    SOVERSION 0
+    VERSION ${CMAKE_PROJECT_VERSION}
+    SOVERSION ${INVENTOR_SOVERSION}
 )
 
 target_include_directories(InventorXt PRIVATE

=== debian/changelog ===
inventor (2.1.6.1+ds-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [321412f] Remove obsolete lintian override (lib SOVERSION was set to
    1 in 2013).
  * [be9c3e2] Override lintian diagnostic for weirdly-named makefile.
  * [95b718a] Remove patches applied upstream.
  * [b46a662] add upstream metadata

  [ Steve M. Robbins ]
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)

 -- Steve M. Robbins <smr@debian.org>  Mon, 08 Dec 2025 22:46:45 -0600

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libfreetype-dev,
                libjpeg-dev,
                bison
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/inventor
 Vcs-Git: https://salsa.debian.org/science-team/inventor.git
